package oesf.ace;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;

/**
 * 6.1　ソケット通信
 * リスト6-1-1　ソケット通信のサンプルプログラム
 */


public class SocketService extends Service {
	private final static int PORT = 10000;
	private final static String IP = "192.168.1.10";
	private Socket socket;
	private InputStream in;
	private OutputStream out;
	private Thread thread;

	@Override
	public void onCreate() {
		super.onCreate();
		thread = new Thread() {
			public void run() {
				try {
					connect();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		};
	}

	@Override
	public void onStart(Intent intent, int startId) {
		super.onStart(intent, startId);
		if (!thread.isAlive()) {
			thread.start();
		}
	}

	private void connect() {
		int size;
		byte[] w = new byte[1024];
		try {
			socket = new Socket(); // Socketクラスのインスタンス生成
			socket.connect(new InetSocketAddress(IP, PORT)); // 接続
			//入出力用ストリームの取得
			in = socket.getInputStream();
			out = socket.getOutputStream();
		} catch (Exception e) {
			e.printStackTrace();
		}
		//データ受信用ループ
		while (socket != null && socket.isConnected()) {
			try {
				size = in.read(w); // データ受信
				if (size < 1) {
					continue;
				}
				// 受信データをそのままサーバへ送信
				out.write(w);
				out.flush();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		if (thread != null) {
			thread.stop();
			thread = null;
		}
		if (socket != null) {
			try {
				socket.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			socket = null;
		}
		if (in != null) {
			try {
				in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			in = null;
		}
		if (out != null) {
			try {
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			out = null;
		}
	}
}
